=encoding utf8

=head1 NAME

Mail::Message::Field::Flex - one line of a message header

=head1 INHERITANCE

 Mail::Message::Field::Flex
   is a Mail::Message::Field
   is a Mail::Reporter

=head1 SYNOPSIS

=head1 DESCRIPTION

This is the flexible implementation of a field: it can easily be
extended because it stores its data in a hash and the constructor
(C<new>) and initializer (C<init>) are split.  However, you pay the
price in performance.  L<Mail::Message::Field::Fast|Mail::Message::Field::Fast> is faster (as the
name predicts).

Extends L<"DESCRIPTION" in Mail::Message::Field|Mail::Message::Field/"DESCRIPTION">.

=head1 OVERLOADED

Extends L<"OVERLOADED" in Mail::Message::Field|Mail::Message::Field/"OVERLOADED">.

=over 4

=item overload: B<'""'> stringification

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<'0+'> numification

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<'<=>'> numeric comparison

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<bool> boolean

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<cmp> string comparison

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Message::Field|Mail::Message::Field/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Message::Field|Mail::Message::Field/"Constructors">.

=over 4

=item $obj-E<gt>B<clone>()

Inherited, see L<Mail::Message::Field/"Constructors">

=item $class-E<gt>B<new>($line | ($name, ($body|$object|\@objects), [@attributes], [\%options|\@options]))

If you stick to this flexible class of header fields, you have a bit
more facilities than with L<Mail::Message::Field::Fast|Mail::Message::Field::Fast>.  Amongst it, you
can specify options with the creation.  Possible arguments:

=over 4

=item * B<new> C<$line>

Pass a C<$line> as it could be found in a file: a (possibly folded) line
which is terminated by a new-line.

=item * B<new> C<$name>, (C<$body>|C<$object>|\C<@objects>), [C<@attributes>], [\C<%options>|\C<@options>]

A set of values which shape the line.

=back

To be able to distinguish the different parameters, you will have
to specify the C<@options> as ARRAY of option PAIRS, or HASH of C<%options>.
The C<@attributes> are a flat LIST of key-value PAIRS.  The C<$body> is
specified as one string, one C<$object>, or an ARRAY of C<@objects>.
See L<Mail::Message::Field|Mail::Message::Field>.
Improves base, see L<Mail::Message::Field/"Constructors">

 -Option    --Default
  attributes  +[ ]
  comment     undef

=over 2

=item attributes => \@attributes|\%attributes

An ARRAY with contains of key-value pairs representing C<@attributes>,
or reference to a HASH containing these pairs.  This is an alternative
notation for specifying C<@attributes> directly as method arguments.

=item comment => $text

A pre-formatted list of attributes.

=encoding utf8

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Message::Field|Mail::Message::Field/"Attributes">.

=over 4

=item $obj-E<gt>B<Name>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<body>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<folded>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<foldedBody>( [$body] )

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<unfoldedBody>( [$body, [$wrap]] )

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<wellformedName>( [STRING] )

Inherited, see L<Mail::Message::Field/"Attributes">

=back

=head2 The field

Extends L<"The field" in Mail::Message::Field|Mail::Message::Field/"The field">.

=over 4

=item $any-E<gt>B<isStructured>( [$name] )

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<length>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<nrLines>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<print>( [$fh] )

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<size>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<string>( [$wrap] )

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<toDisclose>()

Inherited, see L<Mail::Message::Field/"The field">

=back

=head2 Access to the content

Extends L<"Access to the content" in Mail::Message::Field|Mail::Message::Field/"Access to the content">.

=over 4

=item $obj-E<gt>B<addresses>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<attribute>( $name, [$value] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<attributes>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<comment>( [STRING] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $any-E<gt>B<dateToTimestamp>(STRING)

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $any-E<gt>B<stripCFWS>( [STRING] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<study>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $any-E<gt>B<toDate>( [$time] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<toInt>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=back

=head2 Parsing

Extends L<"Parsing" in Mail::Message::Field|Mail::Message::Field/"Parsing">.

=over 4

=item $obj-E<gt>B<consume>( $line | <$name,<$body|$objects>> )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $obj-E<gt>B<defaultWrapLength>( [$length] )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $any-E<gt>B<fold>( $name, $body, [$maxchars] )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $obj-E<gt>B<setWrapLength>( [$length] )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $obj-E<gt>B<stringifyData>(STRING|ARRAY|$objects)

Inherited, see L<Mail::Message::Field/"Parsing">

=item $obj-E<gt>B<unfold>(STRING)

Inherited, see L<Mail::Message::Field/"Parsing">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Message::Field|Mail::Message::Field/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Message::Field|Mail::Message::Field/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DETAILS

Extends L<"DETAILS" in Mail::Message::Field|Mail::Message::Field/"DETAILS">.

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Warning: field content is not numerical: $content

The numeric value of a field is requested (for instance the C<Lines> or
C<Content-Length> fields should be numerical), however the data contains
weird characters.
Cast by C<toInt()>

=item Error: field name too long (max $count), in '$name'.

It is not specified in the RFCs how long a field name can be, but
at least it should be a few characters shorter than the line wrap.
Cast by C<fold()>

=item Warning: illegal character in field name $name.

A new field is being created which does contain characters not permitted
by the RFCs.  Using this field in messages may break other e-mail clients
or transfer agents, and therefore mutulate or extinguish your message.
Cast by C<consume()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.05,
built on April 10, 2026. Website: F<http://perl.overmeer.net/mailbox/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

